#INCLUDE "PROTHEUS.CH"
#INCLUDE "MSOLE.CH"

/*
Baseado no exemplo abaixo, irei gerar um Pedido de Compras para ser utilizado no Word.
O diferencial  que a tabela ser dinnica, ou seja, ela ser preenchida conforme a
quantidade de itens existentes no Pedido de Compras. S que para que isso possa acontecer,
irei criar tambm uma macro no modelo word que permita fazer com que a quantidade de linhas
seja criada conforme a quantidade de itens no pedido.

O precesso  bem simples, iremos usar o componente OLE.

Esta rotina foi testada em Office 97,200,2003,2007 e 2010. Como no tenho o Office 2013 ainda no pude testar, mas se voc testar e conseguir, escreva e compartilhe sua experiencia.

*/
User Function RCOM152()
	// ------------------------------------------------------------------------//
	// Area de declarao de variaveis                                         //
	//-------------------------------------------------------------------------//

	Local cCadastro	:= OemtoAnsi("Integrao com MS-Word")
	Local aMensagem	:={}
	Local aBotoes   :={}
	Local nOpca	:= 0
	Local nPos	:= 0

	Private cPerg   :=Padr("RCOM152",10)

	//-------------------------------------------------------------------
	// Cria/Verifica as perguntas selecionadas
	//-------------------------------------------------------------------

	Pergunte(cPerg,.F.)
	AjustaSX1()

	AADD(aMensagem,OemToAnsi("Esta rotina ir imprimir o Pedido de compras, clique no boto PARAM para informar o PC a") )
	AADD(aMensagem,OemToAnsi("ser impressa e os demais parametros.") )

	AADD(aBotoes, { 5,.T.,{||  Pergunte(cPerg,.T. )}})
	AADD(aBotoes, { 6,.T.,{|o| nOpca := 1,FechaBatch()}})
	AADD(aBotoes, { 2,.T.,{|o| FechaBatch() }} )

	FormBatch( cCadastro, aMensagem, aBotoes )

	/*
	+------------------------------------------------------------------
	| Variaveis utilizadas para parametros
	+------------------------------------------------------------------
	| Variaveis utilizadas para parametros
	| mv_par01		// Do pedido
	| mv_par02		// Ate o pedido
	| mv_par03		// Arquivo Modelo
	| mv_par04		// Pasta de destino do documento
	| mv_par05		// Mtodo de saida 1 = Impressora 2 = apenas Arquivo
	+-------------------------------------------------------------------
	*/
	If nOpca == 1
		PRIVATE hWord	 	:= OLE_CreateLink()
		PRIVATE cArquivo 	:= Alltrim(mv_par03)
		PRIVATE cPath    	:= AllTrim(mv_par04)
		PRIVATE nImpress	:= mv_par05

		nPos := Rat("\",cPath)
		If nPos <= 0
			cPath := cPath + "\"
		EndIF

		if(!File(cArquivo))
			Alert("Arquivo modelo no existe!")
			return
		Endif

		IF  Upper( Subst( AllTrim( cArquivo ), - 3 ) ) != Upper( AllTrim( "DOT" ) ) .AND.;
			Upper( Subst( AllTrim( cArquivo ), - 4 ) ) != Upper( AllTrim( "DOTM" ) )
	    	MsgAlert( "Arquivo Invalido!"+CRLF+"Extenses permitidas: DOT ou DOTM" )
	    	Return
	    EndIf

		If (hWord < "0")
			Alert("MS-WORD nao encontrado nessa maquina!!!")
			Return
		Endif

		Processa({|| Imprimir() },"Aguarde...")
	EndIf


Return


Static Function Imprimir()
	// ------------------------------------------------------------------------//
	// Area de declarao de variaveis                                         //
	//-------------------------------------------------------------------------//
	Local cComprador:= ""
	Local cEmailComp:= ""
	Local cTelComp	:= ""
	Local _aItem   	:= {}
	Local _aQtd    	:= {}
	Local _aUnd    	:= {}
	Local _aDesc 	:= {}
	Local _aPreco	:= {}
	Local _aEntr 	:= {}
	Local _aCodPro 	:= {}
	Local _cNum  	:= ""
	Local _cObs1:=_cObs2:=_cObs3:= ""
	// ------------------------------------------------------------------------//
	// Abre as tabelas para consulta                                           //
	//-------------------------------------------------------------------------//

	dbSelectArea("SA2")
	dbSetOrder(1)
	dbSelectArea("SE4")
	dbSetOrder(1)
	dbSelectArea("SC7")
	dbSetOrder(1)
	dbseek(xfilial("SC7") + mv_par01)
	set softseek off

	ProcRegua(SC7->(RecCount()))

	// Inicializa o Ole com o MS-Word
	BeginMsOle()
		If (hWord >= "0")
			IncProc("Processando documento...")
			OLE_CloseLink(hWord) //fecha o Link com o Word

			hWord := OLE_CreateLink()

			OLE_NewFile(hWord,cArquivo)
			If nImpress==1
				OLE_SetProperty( hWord, oleWdVisible,   .F. )
				OLE_SetProperty( hWord, oleWdPrintBack, .T. )
			Else
				OLE_SetProperty( hWord, oleWdVisible,   .T. )
				OLE_SetProperty( hWord, oleWdPrintBack, .F. )
			EndIf


			While SC7->(!Eof()) .and. SC7->C7_NUM <= mv_par02
				IncProc("Lendo dados da Pedido de Compras...")

				_cNum    := SC7->C7_NUM

				OLE_SaveAsFile(hWord,cPath+"PC" + _cNum + ".DOC")
				//OLE_SaveFile(hWord)

				dbSelectArea("SA2")
				_cNome    := ""
				_cEnd     := ""
				_cBai     := ""
				_cCid     := ""
				_cFone    := ""
				_cCnpj    := ""
				_cInsc    := ""
				_cUf      := ""

				If dbSeek(xFilial("SA2") + SC7->C7_FORNECE + SC7->C7_LOJA)
					_cNome    := A2_NOME
					_cEnd     := A2_END
					_cBai     := A2_BAIRRO
					_cCid     := alltrim(A2_MUN)+" - "+alltrim(A2_EST)+" - "+alltrim(A2_CEP)
					_cFone    := alltrim(A2_DDD)+" - "+alltrim(A2_TEL)
					_cCnpj    := TransForm(A2_CGC,"@R 99.999.999/9999-99")
					_CInsc    := A2_INSCR
					_cUf      := A2_EST
				Endif

				dbSelectArea("SC7")
				If dbSeek(xFilial("SC7") + SC7->C7_NUM)
					_cCondpag := C7_COND
					_dEmissao := C7_EMISSAO
					_cObs1  := C7_OBS
					_cObs2  := ""
					_cObs3  := ""
				Else
					_cCondpag := ""
					_dEmissao := "  /  /  "
					_cObs1  := ""
					_cObs2  := ""
					_cObs3  := ""
				Endif

				dbSelectArea("SE4")
				If dbSeek(xFilial("SE4") + _cCondpag)
					_cCond    := E4_DESCRI
				Else
					_cCond    := ""
				Endif

				dbSelectArea("SC7")
				_cNum    := SC7->C7_NUM
				_aItem   := {}
				_aQtd    := {}
				_aUnd    := {}
				_aDesc   := {}
				_aPreco  := {}
				_aFrete  := {}
				_aEntr   := {}
				_cDesc1  := ""

				While SC7->(!Eof()) .and. SC7->C7_NUM == _cNum

					dbSelectArea("SB5")
					dbSeek(xFilial("SB5") + SC7->C7_PRODUTO)
					_cDesc1:= SB5->B5_CEME

					dbSelectArea("SB1")
					dbSeek(xFilial("SB1") + SC7->C7_PRODUTO)

					dbSelectArea("SC7")
					AADD(_aCodPro ,SC7->C7_PRODUTO)
					AADD(_aItem   ,SC7->C7_ITEM)
					AADD(_aQtd    ,SC7->C7_QUANT)
					AADD(_aUnd    ,SC7->C7_UM)
					AADD(_aDesc   ,SC7->C7_DESCRI)
					AADD(_aPreco,SC7->C7_PRECO)
					AADD(_aEntr ,SC7->C7_DATPRF)

					PSWOrder( 1 )
					If PSWSeek( SC7->C7_COMPRAD , .T.)
						cComprador:= Alltrim(PswRet()[1,4])
						cEmailComp:= Alltrim(PswRet()[1,14])
					Endif

					SC7->(dbSkip())

				Enddo

				nTotItens  := Len(_aItem)

				OLE_SetDocumentVar(hWord, 'TOTAL_DE_ITENS_TABELA1', Str(nTotItens))
				OLE_ExecuteMacro(hWord,"InserirLinhas")

				dbSelectArea("SCR")
				dbSetOrder(1)
				dbSeek(xFilial()+"PC"+SC7->C7_NUM)

				_cAprov := IIf(!empty(SCR->CR_USER),AllTrim(UsrFullName(SCR->CR_USER)),"")

				OLE_SetDocumentVar(hWord,"cEmpresa"  ,AllTrim(SM0->M0_NOMECOM))
				OLE_SetDocumentVar(hWord,"cHoje"  	 ,StrZero(Day(Date()),2)+"/"+StrZero(Month(Date()),2)+"/"+StrZero(Year(Date()),4) )
				OLE_SetDocumentVar(hWord,"cComprador",cComprador)
				OLE_SetDocumentVar(hWord,"cEmailComp",cEmailComp)
				OLE_SetDocumentVar(hWord,"cAprov"    ,_cAprov)
				OLE_SetDocumentVar(hWord,"cNumPC"    ,_cNum)
				OLE_SetDocumentVar(hWord,"cNome"     ,_cNome)
				OLE_SetDocumentVar(hWord,"cEnd"      ,_cEnd)
				OLE_SetDocumentVar(hWord,"cBai"      ,_cBai)
				OLE_SetDocumentVar(hWord,"cCid"      ,_cCid)
				OLE_SetDocumentVar(hWord,"cUf"       ,_cUf)
				OLE_SetDocumentVar(hWord,"cFone"     ,_cFone)
				OLE_SetDocumentVar(hWord,"cCnpj"     ,_cCnpj)
				OLE_SetDocumentVar(hWord,"cInsc"     ,_cInsc)
				OLE_SetDocumentVar(hWord,"cPed"      ,_cNum)
				OLE_SetDocumentVar(hWord,"cData"     ,_dEmissao)
				OLE_SetDocumentVar(hWord,"cHora"     ,Time())
				OLE_SetDocumentVar(hWord,"cCond"     ,_cCond)
				OLE_SetDocumentVar(hWord,"cObs1"   	 ,_cObs1)
				OLE_SetDocumentVar(hWord,"cObs2"   	 ,_cObs2)
				OLE_SetDocumentVar(hWord,"cObs3"   	 ,_cObs3)


				For I := 1 to nTotItens
					OLE_SetDocumentVar(hWord, "cItem"+Alltrim(Str(i))  		, Alltrim(_aItem[i])   )
					OLE_SetDocumentVar(hWord, "cProduto"+Alltrim(Str(i))	, Alltrim(_aCodPro[i]) )
					OLE_SetDocumentVar(hWord, "cDesc"+Alltrim(Str(i))  		, Alltrim(_aDesc[i]))
					OLE_SetDocumentVar(hWord, "cUM"+Alltrim(Str(i))     	, Alltrim(_aUnd [i]))
					OLE_SetDocumentVar(hWord, "cQtde"+Alltrim(Str(i))     	, transform(_aQtd[i],"@E 9999,999.99"))
					OLE_SetDocumentVar(hWord, "cUnitario"+Alltrim(Str(i))   , transform(_aPreco[i],"@E 9999,999.999"))
					OLE_SetDocumentVar(hWord, "cTotal"+Alltrim(Str(i))     	, transform(Round(_aQtd[i]*_aPreco[i],2),"@E 9999,999.999"))
					OLE_SetDocumentVar(hWord, "cData"+Alltrim(Str(i))    	, _aEntr[i])
				Next

				//--Atualiza Variaveis
				OLE_UpDateFields(hWord)
				OLE_SaveFile ( hWord )

				IF nImpress==1
					OLE_SetProperty( hWord, '208', .F. )
					OLE_PrintFile( hWord, "ALL",,, 1 )
					OLE_CloseLink( hWord )//fecha o Link com o Word
				else
					Aviso("Ateno", "Alterne para o programa do Ms-Word para visualizar o documento PC" + _cNum + ".DOC ou clique no botao para fechar.", {"Fechar"})
					OLE_SaveAsFile(hWord,cPath+"PC" + _cNum + ".DOC")
				Endif


			Enddo
		Endif
	EndMsOle()

	OLE_CloseLink( hWord )//fecha o Link com o Word

Return

Static Function AjustaSx1()
	U_fOWordXB() //Criar consulta padro fOWord caso no exista

	PutSx1(cPerg,"01","Pedido de      ","","","mv_ch1","C",06,0,0,"G","","SC7"   ,"","","mv_par01","","","","","","","","","","","","","","","","",{"","",""},{"","",""},{"","",""})
	PutSx1(cPerg,"02","Pedido ate     ","","","mv_ch2","C",06,0,0,"G","","SC7"   ,"","","mv_par02","","","","","","","","","","","","","","","","",{"","",""},{"","",""},{"","",""})
	//PutSx1(cPerg,"03","Arquivo Modelo ","","","mv_ch3","C",99,0,0,"G","U_fOWord('"+cPerg+"','03','mv_par03')","","","","mv_par03","","","","","","","","","","","","","","","","",{"","",""},{"","",""},{"","",""})
	PutSx1(cPerg,"03","Arquivo Modelo ","","","mv_ch3","C",99,0,0,"G","DIR","","","","mv_par03","","","","","","","","","","","","","","","","",{"","",""},{"","",""},{"","",""})
	PutSx1(cPerg,"04","Pasta Destino  ","","","mv_ch4","C",99,0,0,"G","","HSSDIR","","","mv_par04","","","","","","","","","","","","","","","","",{"","",""},{"","",""},{"","",""})
	PutSX1(cPerg,"05","Sada          ","","","mv_ch5","N",01,0,0,"C","","","","","mv_par05","Impressora", "", "", "","Arquivo")
Return